(* Nova-Simulator
   ==============
   Command input

    J. Rathlev, Schwentinental, (kontakt(a)rathlev-home.de)

   The contents of this file may be used under the terms of the
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.

   last modified:  August 2017
   *)

unit InpCommand;

interface

uses Winapi.Windows, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Forms,
  Vcl.Controls, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, NumberUtils;

type
  TCommandDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    lbDesc: TLabel;
    edCommand: TEdit;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Addr,Command : word;
  public
    { Public declarations }
    function Execute (Pos : TPoint; Desc : string;  AAddr : word;
      ANumFormat : TNumMode; var ACommand : word) : boolean;
  end;

var
  CommandDialog: TCommandDialog;

implementation

uses NovaMain, NovaUtils, WinUtils, GnuGetText;

{$R *.DFM}

procedure TCommandDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent(self);
  end;

procedure TCommandDialog.FormShow(Sender: TObject);
begin
  edCommand.SelectAll;
  end;

procedure TCommandDialog.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if ModalResult=mrOK then begin
    CanClose:=Assemble(edCommand.Text,Addr,Command) or (ModalResult=mrCancel);
    if not CanClose then begin
      ErrorDialog (BottomLeftPos(OkBtn),_('Invalid command!')); //Ungltiger Befehl!
      edCommand.SetFocus;
      end;
    end;
  end;

function TCommandDialog.Execute (Pos : TPoint; Desc : string; AAddr : word;
  ANumFormat : TNumMode; var ACommand : word) : boolean;
begin
  with Pos do if X<0 then Position:=poDesktopCenter
  else begin
    Position:=poDesigned;
    CheckScreenBounds(Screen,x,y,Width,Height);
    Left:=x; Top:=y;
    end;
  lbDesc.Caption:=Desc;
  Command:=ACommand;
  Addr:=AAddr;
  edCommand.Text:=Disassemble(-1,Command,ANumFormat,false);
  ActiveControl:=edCommand;
  if ShowModal=mrOK then begin
    ACommand:=Command;
    Result:=true;
    end
  else Result:=false;
  end;

end.
