(* Nova-Simulator
   ==============
   Write program code listing

    J. Rathlev, Schwentinental, (kontakt(a)rathlev-home.de)

   The contents of this file may be used under the terms of the
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.

   last modified:  August 2017
   *)

unit WriteProg;

interface

uses Winapi.Windows, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Forms,
  Vcl.Controls, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, NumberUtils, NumberEd;

type
  TWritePrgDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    edFirstAdr: TNumberEdit;
    edLastAdr: TNumberEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    cbColAdr: TCheckBox;
    cbColCnt: TCheckBox;
    cbColCmd: TCheckBox;
    GroupBox3: TGroupBox;
    rbDecimal: TRadioButton;
    rbOctal: TRadioButton;
    rbHex: TRadioButton;
    rbBin: TRadioButton;
    procedure rbBinClick(Sender: TObject);
    procedure rbOctalClick(Sender: TObject);
    procedure rbDecimalClick(Sender: TObject);
    procedure rbHexClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function Execute (Pos : TPoint; var ANumMode : TNumMode;
                      var AFirst,ALast,AMode : word) : boolean;
  end;

var
  WritePrgDialog: TWritePrgDialog;

implementation

{$R *.DFM}

uses WinUtils, GnuGetText;

procedure TWritePrgDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent(self);
  end;

procedure TWritePrgDialog.rbBinClick(Sender: TObject);
begin
  edFirstAdr.NumMode:=nmBin;
  edLastAdr.NumMode:=nmBin;
  end;

procedure TWritePrgDialog.rbOctalClick(Sender: TObject);
begin
  edFirstAdr.NumMode:=nmOctal;
  edLastAdr.NumMode:=nmOctal;
  end;

procedure TWritePrgDialog.rbDecimalClick(Sender: TObject);
begin
  edFirstAdr.NumMode:=nmDecimal;
  edLastAdr.NumMode:=nmDecimal;
  end;

procedure TWritePrgDialog.rbHexClick(Sender: TObject);
begin
  edFirstAdr.NumMode:=nmHex;
  edLastAdr.NumMode:=nmHex;
  end;

function TWritePrgDialog.Execute (Pos : TPoint; var ANumMode : TNumMode;
                  var AFirst,ALast,AMode : word) : boolean;
begin
  with Pos do if X<0 then Position:=poDesktopCenter
  else begin
    Position:=poDesigned;
    x:=x-Width;
    CheckScreenBounds(Screen,x,y,Width,Height);
    Left:=x; Top:=y;
    end;
  with edFirstAdr do begin
    Value:=AFirst;
    NumMode:=ANumMode;
    end;
  with edLastAdr do begin
    Value:=ALast;
    NumMode:=ANumMode;
    end;
  cbColAdr.Checked:=AMode and 1 <>0;
  cbColCnt.Checked:=AMode and 2 <>0;
  cbColCmd.Checked:=AMode and 4 <>0;
  case ANumMode of
  nmBin : rbBin.Checked:=true;
  nmOctal : rbOctal.Checked:=true;
  nmHex : rbHex.Checked:=true;
  else rbDecimal.Checked:=true;
    end;
  if ShowModal=mrOK then begin
    AFirst:=edFirstAdr.Value;
    ALast:=edLastAdr.Value;
    if cbColAdr.Checked then AMode:=1 else AMode:=0;
    if cbColCnt.Checked then AMode:=AMode or 2;
    if cbColCmd.Checked then AMode:=AMode or 4;
    ANumMode:=edFirstAdr.NumMode;
    Result:=true;
    end
  else Result:=false;
  end;

end.
